function Player::GetNESWBricks(%player)
{
	%pos = %player.getPosition();
	%scale = %player.getScale();
	%xs = getWord(%scale,0);
	%ys = getWord(%scale,1);

	%n = vectorAdd(%pos,"0 -" @ (%ys / 2) + 0.5 SPC "0");
	%e = vectorAdd(%pos,(%xs / 2) + 0.5 SPC "0 0");
	%s = vectorAdd(%pos,"0" SPC (%ys / 2) + 0.5 SPC "0");
	%w = vectorAdd(%pos,"-" @ (%xs / 2) + 0.5 SPC "0 0");

	%rayn = getWord(containerRaycast(%pos,%n,$TypeMasks::FxBrickAlwaysObjectType|$TypeMasks::InteriorObjectType),0);
	%raye = getWord(containerRaycast(%pos,%e,$TypeMasks::FxBrickAlwaysObjectType|$TypeMasks::InteriorObjectType),0);
	%rays = getWord(containerRaycast(%pos,%s,$TypeMasks::FxBrickAlwaysObjectType|$TypeMasks::InteriorObjectType),0);
	%rayw = getWord(containerRaycast(%pos,%w,$TypeMasks::FxBrickAlwaysObjectType|$TypeMasks::InteriorObjectType),0);

	%n = ag_bicheck(%rayn);
	%e = ag_bicheck(%raye);
	%s = ag_bicheck(%rays);
	%w = ag_bicheck(%rayw);

	return %n TAB %e TAB %s TAB %w;
}
function ag_bicheck(%obj)
{
	if(!isObject(%obj))
	{
		return 0;
	}
	if(%obj.getClassName() $= "fxDTSbrick")
	{
		if(%obj.isColliding() && %obj.isRendering())
		{
			return 1;
		}
		return 0;
	}
	return 1;
}
function Player::IsOnGround(%player)
{
	%pos = %player.getPosition();
	%scale = %player.getScale();
	%xs = getWord(%scale,0);
	%ys = getWord(%scale,1);
	
	%nw = vectorAdd(%pos,0 - (0.75 * %xs) SPC 0 - (0.75 * %ys) SPC 0);
	%dnw = vectorAdd(%nw,"0 0 -0.5");
	%ne = vectorAdd(%pos,(0.75 * %xs) SPC 0 - (0.75 * %ys) SPC 0);
	%dne = vectorAdd(%ne,"0 0 -0.5");
	%se = vectorAdd(%pos,(0.75 * %xs) SPC (0.75 * %ys) SPC 0);
	%dse = vectorAdd(%se,"0 0 -0.5");
	%sw = vectorAdd(%pos,0 - (0.75 * %xs) SPC (0.75 * %ys) SPC 0);
	%dsw = vectorAdd(%sw,"0 0 -0.5");
	%dpos = vectorAdd(%pos,"0 0 -0.5");

	%raynw = ag_bicheck(getWord(containerRaycast(%nw,%dnw,$TypeMasks::FxBrickAlwaysObjectType|$TypeMasks::InteriorObjectType),0));
	%rayne = ag_bicheck(getWord(containerRaycast(%ne,%dne,$TypeMasks::FxBrickAlwaysObjectType|$TypeMasks::InteriorObjectType),0));
	%rayse = ag_bicheck(getWord(containerRaycast(%se,%dse,$TypeMasks::FxBrickAlwaysObjectType|$TypeMasks::InteriorObjectType),0));
	%raysw = ag_bicheck(getWord(containerRaycast(%sw,%dsw,$TypeMasks::FxBrickAlwaysObjectType|$TypeMasks::InteriorObjectType),0));
	%rayce = ag_bicheck(getWord(containerRaycast(%pos,%dpos,$TypeMasks::FxBrickAlwaysObjectType|$TypeMasks::InteriorObjectType),0));

	if(%raynw || %rayne || %rayse || %raysw || %rayce)
	{
		return 1;
	} else {
		return 0;
	}
}

function Player::canUseAgile(%player)
{
	// YOU CAN PACKAGE THIS SHIT
	// GO NUTS
	%db = %player.getDatablock();
	%r = 0;
	if(%db.ag_isAgile && !%db.canJet)
	{
		%r = 1;
		if(!%db.ag_isAlwaysAgile)
		{
			if(isObject(%player.getMountedImage(0)))
			{
				if(!%player.getMountedImage(0).ag_canUseAgile)
				{
					%r = 0;
				}
			}
		}
	}
	return %r;
}
function Player::getHorizJumpForce(%player)
{
	// YOU CAN PACKAGE THIS SHIT TOO
	return %player.getDatablock().ag_horizJumpForce;
}
function Player::getVertJumpForce(%player)
{
	// YEP THIS ONE AS WELL
	return %player.getDatablock().ag_vertJumpForce;
}
function Player::getClimbEnergyUse(%player)
{
	// YES ALSO THIS
	return %player.getDatablock().ag_energyDrain;
}

function Player::ag_Climb(%player)
{
	cancel(%player.ag_climb);
	if(%player.isOnGround())
	{
		%player.ag_climb = %player.schedule(%player.getdatablock().ag_actInt,"ag_Climb");
		return;
	}
	%dbn = %player.getClimbEnergyUse();
	%actint = %player.getDatablock().ag_actInt;
	%needs = %dbn * ((%actint / 1000) * 4);
	%energy = %player.getEnergyLevel();
	if(%energy >= %needs)
	{
		%bricks = %player.getNESWBricks();
		%n = getField(%bricks,0);
		%e = getField(%bricks,1);
		%s = getField(%bricks,2);
		%w = getField(%bricks,3);
		%climb = (%n || %e || %s || %w);
		if(%climb)
		{
			%up = %player.getVertJumpForce() * ((%actint / 1000) * 10);
			%vel = %player.getVelocity();

			%x = getWord(%vel,0) * 0.965;
			%y = getWord(%vel,1) * 0.965;
			%z = mClampF(getWord(%vel,2) + %up,-200,%player.getVertJumpForce() * 1.5);

			%vel = %x SPC %y SPC %z;

			%player.setVelocity(%vel);
			%player.setEnergyLevel(%energy - %needs);
			if(!%player.ag_pt_climb)
			{
				%player.playThread(2,"side");
				%player.ag_pt_climb = 1;
			}
			if($Sim::Time - %player.ag_lpt_climb > 0.4 && (%x < 3 || %y < 3))
			{
				%player.playThread(0,"jump");
				%player.ag_lpt_climb = $Sim::Time;
			}
		} else {
			%player.stopthread(2);
			%player.ag_pt_climb = 0;
		}
	}
	%player.ag_climb = %player.schedule(%player.getdatablock().ag_actInt,"ag_Climb");
}
function Player::ag_Jump(%player)
{
	cancel(%player.ag_jump);
	if(!%player.isOnGround())
	{
		%bricks = %player.getNESWBricks();
		%n = getField(%bricks,0);
		%e = getField(%bricks,1);
		%s = getField(%bricks,2);
		%w = getField(%bricks,3);
		%energy = %player.getEnergyLevel();
		%needs = %player.getClimbEnergyUse();
		%time = $Sim::Time - %player.ag_lastJumpTime;

		if((%n || %e || %s || %w) && %energy >= %needs && %time > 0.075)
		{
			%player.ag_lastJumpTime = $Sim::Time;
			%h = %player.getHorizJumpForce();
			%v = %player.getVertJumpForce();
			%vel = %player.getVelocity();

			%x = (0 - (%e * %h)) + (%w * %h);
			%y = (%n * %h) + (0 - (%s * %h));
			%z = mClampF(((%n || %e || %s || %w) * %v) + getWord(%player.getVelocity(),2),-200,%v * 2);

			if(%x == 0)
			{
				%x = getWord(%vel,0);
			}
			if(%y == 0)
			{
				%y = getWord(%vel,1);
			}
			%player.setVelocity(%x SPC %y SPC %z);
			%player.setEnergyLevel(%energy - %needs);
			%player.playThread(0,"jump");
		}
	}
	%player.ag_jump = %player.schedule(%player.getdatablock().ag_actInt,"ag_Jump");
}

package Agility2
{
	function Armor::onTrigger(%datablock,%player,%slot,%io)
	{
		// 0 Fire
		// 1 Jump
		// 3 Crouch
		// 4 Jet
		Parent::onTrigger(%datablock,%player,%slot,%io);
		if(%player.canUseAgile())
		{
			if(%slot == 2)
			{
				if(%io)
				{
					%player.ag_state_jump = 1;
					if(%player.isOnGround())
					{
						%player.ag_jump = %player.schedule(250,"ag_jump");
					} else {
						%player.ag_jump();
					}
				} else {
					%player.ag_state_jump = 0;
					cancel(%player.ag_jump);
				}

			}
			if(%slot == 4)
			{
				if(%io)
				{
					// They started jetting, so they started climbing
					%player.ag_state_climb = 1;
					%player.ag_climb();
				} else {
					// They stopped climbing
					%player.ag_state_climb = 0;
					cancel(%player.ag_climb);
					%player.stopThread(2);
					%player.ag_pt_climb = 0;
				}
			}
		}
	}
};
activatePackage(Agility2);

datablock PlayerData(PlayerAgile : PlayerStandardArmor)
{
	canRide = 1;

	runForce = 4320;
	runEnergyDrain = -0.15;
	minRunEnergy = 0;

	maxForwardSpeed = 14;

	maxForwardCrouchSpeed = 5;
	maxBackwardCrouchSpeed = 5;
	maxSideCrouchSpeed = 5;

	jumpForce = 1080;
	jumpEnergyDrain = 0;
	minJumpEnergy = 0;
	jumpDelay = 0;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	showHealthBar = 1;
	showEnergyBar = 1;
	maxEnergy = 120;
	rechargeRate = 0.1;

	maxDamage = 100;

	ag_isAgile = 1;
	ag_isAlwaysAgile = 0;
	ag_horizJumpForce = 10;
	ag_vertJumpForce = 4;
	ag_energyDrain = 8;
	ag_actInt = 33;

	airControl = 0.15;

	uiName = "Agile Player";

	isSurvivor = 1;
};